> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/io/directorycopy.md).

# DirectoryCopy

Copies a directory from one location to another

## Method Signature

```
DirectoryCopy(source=[string], destination=[string], recurse=[boolean], filter=[any], createPath=[boolean], overwrite=[boolean])
```

### Arguments

| Argument      | Type      | Required | Description                                                      | Default |
| ------------- | --------- | -------- | ---------------------------------------------------------------- | ------- |
| `source`      | `string`  | `true`   | The source directory                                             |         |
| `destination` | `string`  | `true`   | The destination directory                                        |         |
| `recurse`     | `boolean` | `false`  | whether to recurse in to sub-directories and create paths        | `false` |
| `filter`      | `any`     | `false`  | A file or directory filter to pass                               | `*`     |
| `createPath`  | `boolean` | `false`  | whether to create any nested paths required to the new directory | `true`  |
| `overwrite`   | `boolean` | `false`  | whether to overwrite existing files at the destination           | `false` |

## Examples

### Simple DirectoryCopy Example

Copy directory from one place to another.

```java
directoryCopy( expandPath( "./mySourceDirectory" ), expandPath( "../MyDestinationDirectory" ) );

```

### Additional Examples

[Run Example](https://try.boxlang.io/?code=eJxLySxKTS7JL6pMzi%2Bo1FBQSoHxCxJLMpR00AUUNK25FPT1FfLzUhVQZBRK8hUS8%2FJLMlKLEBIKIBk9PT0uAG2KJCs%3D)

```java
directorycopy( "directorypath", "directorypath" );
 // one directorypath to another directory path...

```

## Related

* [ContractPath](/boxlang-language/reference/built-in-functions/io/contractpath.md)
* [CreateTempDirectory](/boxlang-language/reference/built-in-functions/io/createtempdirectory.md)
* [CreateTempFile](/boxlang-language/reference/built-in-functions/io/createtempfile.md)
* [DirectoryCreate](/boxlang-language/reference/built-in-functions/io/directorycreate.md)
* [DirectoryDelete](/boxlang-language/reference/built-in-functions/io/directorydelete.md)
* [DirectoryExists](/boxlang-language/reference/built-in-functions/io/directoryexists.md)
* [DirectoryList](/boxlang-language/reference/built-in-functions/io/directorylist.md)
* [DirectoryMove](/boxlang-language/reference/built-in-functions/io/directorymove.md)
* [DirectoryRename](/boxlang-language/reference/built-in-functions/io/directoryrename.md)
* [ExpandPath](/boxlang-language/reference/built-in-functions/io/expandpath.md)
* [FileAppend](/boxlang-language/reference/built-in-functions/io/fileappend.md)
* [FileClose](/boxlang-language/reference/built-in-functions/io/fileclose.md)
* [FileCopy](/boxlang-language/reference/built-in-functions/io/filecopy.md)
* [FileDelete](/boxlang-language/reference/built-in-functions/io/filedelete.md)
* [FileExists](/boxlang-language/reference/built-in-functions/io/fileexists.md)
* [FileGetMimeType](/boxlang-language/reference/built-in-functions/io/filegetmimetype.md)
* [FileInfo](/boxlang-language/reference/built-in-functions/io/fileinfo.md)
* [FileIsEOF](/boxlang-language/reference/built-in-functions/io/fileiseof.md)
* [FileMove](/boxlang-language/reference/built-in-functions/io/filemove.md)
* [FileOpen](/boxlang-language/reference/built-in-functions/io/fileopen.md)
* [FileRead](/boxlang-language/reference/built-in-functions/io/fileread.md)
* [FileReadBinary](/boxlang-language/reference/built-in-functions/io/filereadbinary.md)
* [FileReadLine](/boxlang-language/reference/built-in-functions/io/filereadline.md)
* [FileSeek](/boxlang-language/reference/built-in-functions/io/fileseek.md)
* [FileSetAccessMode](/boxlang-language/reference/built-in-functions/io/filesetaccessmode.md)
* [FileSetAttribute](/boxlang-language/reference/built-in-functions/io/filesetattribute.md)
* [FileSetLastModified](/boxlang-language/reference/built-in-functions/io/filesetlastmodified.md)
* [FileSkipBytes](/boxlang-language/reference/built-in-functions/io/fileskipbytes.md)
* [FileWrite](/boxlang-language/reference/built-in-functions/io/filewrite.md)
* [FileWriteLine](/boxlang-language/reference/built-in-functions/io/filewriteline.md)
* [GetCanonicalPath](/boxlang-language/reference/built-in-functions/io/getcanonicalpath.md)
* [GetDirectoryFromPath](/boxlang-language/reference/built-in-functions/io/getdirectoryfrompath.md)
* [GetFileInfo](/boxlang-language/reference/built-in-functions/io/getfileinfo.md)
* [getTempFile](/boxlang-language/reference/built-in-functions/io/gettempfile.md)
* [PropertyFile](/boxlang-language/reference/built-in-functions/io/propertyfile.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/io/directorycopy.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
